# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""JobSpec describes how the job execution will look like.

    IoK8sApiBatchV1JobSpec(;
        activeDeadlineSeconds=nothing,
        backoffLimit=nothing,
        completions=nothing,
        manualSelector=nothing,
        parallelism=nothing,
        selector=nothing,
        template=nothing,
        ttlSecondsAfterFinished=nothing,
    )

    - activeDeadlineSeconds::Int64 : Specifies the duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer
    - backoffLimit::Int32 : Specifies the number of retries before marking this job failed. Defaults to 6
    - completions::Int32 : Specifies the desired number of successfully finished pods the job should be run with.  Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/
    - manualSelector::Bool : manualSelector controls generation of pod labels and pod selectors. Leave &#x60;manualSelector&#x60; unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see &#x60;manualSelector&#x3D;true&#x60; in jobs that were created with the old &#x60;extensions/v1beta1&#x60; API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector
    - parallelism::Int32 : Specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) &lt; .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/
    - selector::IoK8sApimachineryPkgApisMetaV1LabelSelector : A label query over pods that should match the pod count. Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors
    - template::IoK8sApiCoreV1PodTemplateSpec : Describes the pod that will be created when executing a job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/
    - ttlSecondsAfterFinished::Int32 : ttlSecondsAfterFinished limits the lifetime of a Job that has finished execution (either Complete or Failed). If this field is set, ttlSecondsAfterFinished after the Job finishes, it is eligible to be automatically deleted. When the Job is being deleted, its lifecycle guarantees (e.g. finalizers) will be honored. If this field is unset, the Job won&#39;t be automatically deleted. If this field is set to zero, the Job becomes eligible to be deleted immediately after it finishes. This field is alpha-level and is only honored by servers that enable the TTLAfterFinished feature.
"""
mutable struct IoK8sApiBatchV1JobSpec <: SwaggerModel
    activeDeadlineSeconds::Any # spec type: Union{ Nothing, Int64 } # spec name: activeDeadlineSeconds
    backoffLimit::Any # spec type: Union{ Nothing, Int32 } # spec name: backoffLimit
    completions::Any # spec type: Union{ Nothing, Int32 } # spec name: completions
    manualSelector::Any # spec type: Union{ Nothing, Bool } # spec name: manualSelector
    parallelism::Any # spec type: Union{ Nothing, Int32 } # spec name: parallelism
    selector::Any # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1LabelSelector } # spec name: selector
    template::Any # spec type: Union{ Nothing, IoK8sApiCoreV1PodTemplateSpec } # spec name: template
    ttlSecondsAfterFinished::Any # spec type: Union{ Nothing, Int32 } # spec name: ttlSecondsAfterFinished

    function IoK8sApiBatchV1JobSpec(;activeDeadlineSeconds=nothing, backoffLimit=nothing, completions=nothing, manualSelector=nothing, parallelism=nothing, selector=nothing, template=nothing, ttlSecondsAfterFinished=nothing)
        o = new()
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("activeDeadlineSeconds"), activeDeadlineSeconds)
        setfield!(o, Symbol("activeDeadlineSeconds"), activeDeadlineSeconds)
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("backoffLimit"), backoffLimit)
        setfield!(o, Symbol("backoffLimit"), backoffLimit)
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("completions"), completions)
        setfield!(o, Symbol("completions"), completions)
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("manualSelector"), manualSelector)
        setfield!(o, Symbol("manualSelector"), manualSelector)
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("parallelism"), parallelism)
        setfield!(o, Symbol("parallelism"), parallelism)
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("selector"), selector)
        setfield!(o, Symbol("selector"), selector)
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("template"), template)
        setfield!(o, Symbol("template"), template)
        validate_property(IoK8sApiBatchV1JobSpec, Symbol("ttlSecondsAfterFinished"), ttlSecondsAfterFinished)
        setfield!(o, Symbol("ttlSecondsAfterFinished"), ttlSecondsAfterFinished)
        o
    end
end # type IoK8sApiBatchV1JobSpec

const _property_map_IoK8sApiBatchV1JobSpec = Dict{Symbol,Symbol}(Symbol("activeDeadlineSeconds")=>Symbol("activeDeadlineSeconds"), Symbol("backoffLimit")=>Symbol("backoffLimit"), Symbol("completions")=>Symbol("completions"), Symbol("manualSelector")=>Symbol("manualSelector"), Symbol("parallelism")=>Symbol("parallelism"), Symbol("selector")=>Symbol("selector"), Symbol("template")=>Symbol("template"), Symbol("ttlSecondsAfterFinished")=>Symbol("ttlSecondsAfterFinished"))
const _property_types_IoK8sApiBatchV1JobSpec = Dict{Symbol,String}(Symbol("activeDeadlineSeconds")=>"Int64", Symbol("backoffLimit")=>"Int32", Symbol("completions")=>"Int32", Symbol("manualSelector")=>"Bool", Symbol("parallelism")=>"Int32", Symbol("selector")=>"IoK8sApimachineryPkgApisMetaV1LabelSelector", Symbol("template")=>"IoK8sApiCoreV1PodTemplateSpec", Symbol("ttlSecondsAfterFinished")=>"Int32")
Base.propertynames(::Type{ IoK8sApiBatchV1JobSpec }) = collect(keys(_property_map_IoK8sApiBatchV1JobSpec))
Swagger.property_type(::Type{ IoK8sApiBatchV1JobSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiBatchV1JobSpec[name]))}
Swagger.field_name(::Type{ IoK8sApiBatchV1JobSpec }, property_name::Symbol) =  _property_map_IoK8sApiBatchV1JobSpec[property_name]

function check_required(o::IoK8sApiBatchV1JobSpec)
    (getproperty(o, Symbol("template")) === nothing) && (return false)
    true
end

function validate_property(::Type{ IoK8sApiBatchV1JobSpec }, name::Symbol, val)
end
