# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""An EphemeralContainer is a container that may be added temporarily to an existing pod for user-initiated activities such as debugging. Ephemeral containers have no resource or scheduling guarantees, and they will not be restarted when they exit or when a pod is removed or restarted. If an ephemeral container causes a pod to exceed its resource allocation, the pod may be evicted. Ephemeral containers may not be added by directly updating the pod spec. They must be added via the pod&#39;s ephemeralcontainers subresource, and they will appear in the pod spec once added. This is an alpha feature enabled by the EphemeralContainers feature flag.

    IoK8sApiCoreV1EphemeralContainer(;
        args=nothing,
        command=nothing,
        env=nothing,
        envFrom=nothing,
        image=nothing,
        imagePullPolicy=nothing,
        lifecycle=nothing,
        livenessProbe=nothing,
        name=nothing,
        ports=nothing,
        readinessProbe=nothing,
        resources=nothing,
        securityContext=nothing,
        startupProbe=nothing,
        stdin=nothing,
        stdinOnce=nothing,
        targetContainerName=nothing,
        terminationMessagePath=nothing,
        terminationMessagePolicy=nothing,
        tty=nothing,
        volumeDevices=nothing,
        volumeMounts=nothing,
        workingDir=nothing,
    )

    - args::Vector{String} : Arguments to the entrypoint. The docker image&#39;s CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container&#39;s environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
    - command::Vector{String} : Entrypoint array. Not executed within a shell. The docker image&#39;s ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container&#39;s environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell
    - env::Vector{IoK8sApiCoreV1EnvVar} : List of environment variables to set in the container. Cannot be updated.
    - envFrom::Vector{IoK8sApiCoreV1EnvFromSource} : List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.
    - image::String : Docker image name. More info: https://kubernetes.io/docs/concepts/containers/images
    - imagePullPolicy::String : Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images
    - lifecycle::IoK8sApiCoreV1Lifecycle : Lifecycle is not allowed for ephemeral containers.
    - livenessProbe::IoK8sApiCoreV1Probe : Probes are not allowed for ephemeral containers.
    - name::String : Name of the ephemeral container specified as a DNS_LABEL. This name must be unique among all containers, init containers and ephemeral containers.
    - ports::Vector{IoK8sApiCoreV1ContainerPort} : Ports are not allowed for ephemeral containers.
    - readinessProbe::IoK8sApiCoreV1Probe : Probes are not allowed for ephemeral containers.
    - resources::IoK8sApiCoreV1ResourceRequirements : Resources are not allowed for ephemeral containers. Ephemeral containers use spare resources already allocated to the pod.
    - securityContext::IoK8sApiCoreV1SecurityContext : SecurityContext is not allowed for ephemeral containers.
    - startupProbe::IoK8sApiCoreV1Probe : Probes are not allowed for ephemeral containers.
    - stdin::Bool : Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.
    - stdinOnce::Bool : Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false
    - targetContainerName::String : If set, the name of the container from PodSpec that this ephemeral container targets. The ephemeral container will be run in the namespaces (IPC, PID, etc) of this container. If not set then the ephemeral container is run in whatever namespaces are shared for the pod. Note that the container runtime must support this feature.
    - terminationMessagePath::String : Optional: Path at which the file to which the container&#39;s termination message will be written is mounted into the container&#39;s filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.
    - terminationMessagePolicy::String : Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.
    - tty::Bool : Whether this container should allocate a TTY for itself, also requires &#39;stdin&#39; to be true. Default is false.
    - volumeDevices::Vector{IoK8sApiCoreV1VolumeDevice} : volumeDevices is the list of block devices to be used by the container. This is a beta feature.
    - volumeMounts::Vector{IoK8sApiCoreV1VolumeMount} : Pod volumes to mount into the container&#39;s filesystem. Cannot be updated.
    - workingDir::String : Container&#39;s working directory. If not specified, the container runtime&#39;s default will be used, which might be configured in the container image. Cannot be updated.
"""
mutable struct IoK8sApiCoreV1EphemeralContainer <: SwaggerModel
    args::Any # spec type: Union{ Nothing, Vector{String} } # spec name: args
    command::Any # spec type: Union{ Nothing, Vector{String} } # spec name: command
    env::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1EnvVar} } # spec name: env
    envFrom::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1EnvFromSource} } # spec name: envFrom
    image::Any # spec type: Union{ Nothing, String } # spec name: image
    imagePullPolicy::Any # spec type: Union{ Nothing, String } # spec name: imagePullPolicy
    lifecycle::Any # spec type: Union{ Nothing, IoK8sApiCoreV1Lifecycle } # spec name: lifecycle
    livenessProbe::Any # spec type: Union{ Nothing, IoK8sApiCoreV1Probe } # spec name: livenessProbe
    name::Any # spec type: Union{ Nothing, String } # spec name: name
    ports::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1ContainerPort} } # spec name: ports
    readinessProbe::Any # spec type: Union{ Nothing, IoK8sApiCoreV1Probe } # spec name: readinessProbe
    resources::Any # spec type: Union{ Nothing, IoK8sApiCoreV1ResourceRequirements } # spec name: resources
    securityContext::Any # spec type: Union{ Nothing, IoK8sApiCoreV1SecurityContext } # spec name: securityContext
    startupProbe::Any # spec type: Union{ Nothing, IoK8sApiCoreV1Probe } # spec name: startupProbe
    stdin::Any # spec type: Union{ Nothing, Bool } # spec name: stdin
    stdinOnce::Any # spec type: Union{ Nothing, Bool } # spec name: stdinOnce
    targetContainerName::Any # spec type: Union{ Nothing, String } # spec name: targetContainerName
    terminationMessagePath::Any # spec type: Union{ Nothing, String } # spec name: terminationMessagePath
    terminationMessagePolicy::Any # spec type: Union{ Nothing, String } # spec name: terminationMessagePolicy
    tty::Any # spec type: Union{ Nothing, Bool } # spec name: tty
    volumeDevices::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1VolumeDevice} } # spec name: volumeDevices
    volumeMounts::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1VolumeMount} } # spec name: volumeMounts
    workingDir::Any # spec type: Union{ Nothing, String } # spec name: workingDir

    function IoK8sApiCoreV1EphemeralContainer(;args=nothing, command=nothing, env=nothing, envFrom=nothing, image=nothing, imagePullPolicy=nothing, lifecycle=nothing, livenessProbe=nothing, name=nothing, ports=nothing, readinessProbe=nothing, resources=nothing, securityContext=nothing, startupProbe=nothing, stdin=nothing, stdinOnce=nothing, targetContainerName=nothing, terminationMessagePath=nothing, terminationMessagePolicy=nothing, tty=nothing, volumeDevices=nothing, volumeMounts=nothing, workingDir=nothing)
        o = new()
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("args"), args)
        setfield!(o, Symbol("args"), args)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("command"), command)
        setfield!(o, Symbol("command"), command)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("env"), env)
        setfield!(o, Symbol("env"), env)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("envFrom"), envFrom)
        setfield!(o, Symbol("envFrom"), envFrom)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("image"), image)
        setfield!(o, Symbol("image"), image)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("imagePullPolicy"), imagePullPolicy)
        setfield!(o, Symbol("imagePullPolicy"), imagePullPolicy)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("lifecycle"), lifecycle)
        setfield!(o, Symbol("lifecycle"), lifecycle)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("livenessProbe"), livenessProbe)
        setfield!(o, Symbol("livenessProbe"), livenessProbe)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("name"), name)
        setfield!(o, Symbol("name"), name)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("ports"), ports)
        setfield!(o, Symbol("ports"), ports)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("readinessProbe"), readinessProbe)
        setfield!(o, Symbol("readinessProbe"), readinessProbe)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("resources"), resources)
        setfield!(o, Symbol("resources"), resources)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("securityContext"), securityContext)
        setfield!(o, Symbol("securityContext"), securityContext)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("startupProbe"), startupProbe)
        setfield!(o, Symbol("startupProbe"), startupProbe)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("stdin"), stdin)
        setfield!(o, Symbol("stdin"), stdin)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("stdinOnce"), stdinOnce)
        setfield!(o, Symbol("stdinOnce"), stdinOnce)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("targetContainerName"), targetContainerName)
        setfield!(o, Symbol("targetContainerName"), targetContainerName)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("terminationMessagePath"), terminationMessagePath)
        setfield!(o, Symbol("terminationMessagePath"), terminationMessagePath)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("terminationMessagePolicy"), terminationMessagePolicy)
        setfield!(o, Symbol("terminationMessagePolicy"), terminationMessagePolicy)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("tty"), tty)
        setfield!(o, Symbol("tty"), tty)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("volumeDevices"), volumeDevices)
        setfield!(o, Symbol("volumeDevices"), volumeDevices)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("volumeMounts"), volumeMounts)
        setfield!(o, Symbol("volumeMounts"), volumeMounts)
        validate_property(IoK8sApiCoreV1EphemeralContainer, Symbol("workingDir"), workingDir)
        setfield!(o, Symbol("workingDir"), workingDir)
        o
    end
end # type IoK8sApiCoreV1EphemeralContainer

const _property_map_IoK8sApiCoreV1EphemeralContainer = Dict{Symbol,Symbol}(Symbol("args")=>Symbol("args"), Symbol("command")=>Symbol("command"), Symbol("env")=>Symbol("env"), Symbol("envFrom")=>Symbol("envFrom"), Symbol("image")=>Symbol("image"), Symbol("imagePullPolicy")=>Symbol("imagePullPolicy"), Symbol("lifecycle")=>Symbol("lifecycle"), Symbol("livenessProbe")=>Symbol("livenessProbe"), Symbol("name")=>Symbol("name"), Symbol("ports")=>Symbol("ports"), Symbol("readinessProbe")=>Symbol("readinessProbe"), Symbol("resources")=>Symbol("resources"), Symbol("securityContext")=>Symbol("securityContext"), Symbol("startupProbe")=>Symbol("startupProbe"), Symbol("stdin")=>Symbol("stdin"), Symbol("stdinOnce")=>Symbol("stdinOnce"), Symbol("targetContainerName")=>Symbol("targetContainerName"), Symbol("terminationMessagePath")=>Symbol("terminationMessagePath"), Symbol("terminationMessagePolicy")=>Symbol("terminationMessagePolicy"), Symbol("tty")=>Symbol("tty"), Symbol("volumeDevices")=>Symbol("volumeDevices"), Symbol("volumeMounts")=>Symbol("volumeMounts"), Symbol("workingDir")=>Symbol("workingDir"))
const _property_types_IoK8sApiCoreV1EphemeralContainer = Dict{Symbol,String}(Symbol("args")=>"Vector{String}", Symbol("command")=>"Vector{String}", Symbol("env")=>"Vector{IoK8sApiCoreV1EnvVar}", Symbol("envFrom")=>"Vector{IoK8sApiCoreV1EnvFromSource}", Symbol("image")=>"String", Symbol("imagePullPolicy")=>"String", Symbol("lifecycle")=>"IoK8sApiCoreV1Lifecycle", Symbol("livenessProbe")=>"IoK8sApiCoreV1Probe", Symbol("name")=>"String", Symbol("ports")=>"Vector{IoK8sApiCoreV1ContainerPort}", Symbol("readinessProbe")=>"IoK8sApiCoreV1Probe", Symbol("resources")=>"IoK8sApiCoreV1ResourceRequirements", Symbol("securityContext")=>"IoK8sApiCoreV1SecurityContext", Symbol("startupProbe")=>"IoK8sApiCoreV1Probe", Symbol("stdin")=>"Bool", Symbol("stdinOnce")=>"Bool", Symbol("targetContainerName")=>"String", Symbol("terminationMessagePath")=>"String", Symbol("terminationMessagePolicy")=>"String", Symbol("tty")=>"Bool", Symbol("volumeDevices")=>"Vector{IoK8sApiCoreV1VolumeDevice}", Symbol("volumeMounts")=>"Vector{IoK8sApiCoreV1VolumeMount}", Symbol("workingDir")=>"String")
Base.propertynames(::Type{ IoK8sApiCoreV1EphemeralContainer }) = collect(keys(_property_map_IoK8sApiCoreV1EphemeralContainer))
Swagger.property_type(::Type{ IoK8sApiCoreV1EphemeralContainer }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1EphemeralContainer[name]))}
Swagger.field_name(::Type{ IoK8sApiCoreV1EphemeralContainer }, property_name::Symbol) =  _property_map_IoK8sApiCoreV1EphemeralContainer[property_name]

function check_required(o::IoK8sApiCoreV1EphemeralContainer)
    (getproperty(o, Symbol("name")) === nothing) && (return false)
    true
end

function validate_property(::Type{ IoK8sApiCoreV1EphemeralContainer }, name::Symbol, val)
end
