# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""LimitRangeItem defines a min/max usage limit for any resource that matches on kind.

    IoK8sApiCoreV1LimitRangeItem(;
        default=nothing,
        defaultRequest=nothing,
        max=nothing,
        maxLimitRequestRatio=nothing,
        min=nothing,
        type=nothing,
    )

    - default::Dict{String, IoK8sApimachineryPkgApiResourceQuantity} : Default resource requirement limit value by resource name if resource limit is omitted.
    - defaultRequest::Dict{String, IoK8sApimachineryPkgApiResourceQuantity} : DefaultRequest is the default resource requirement request value by resource name if resource request is omitted.
    - max::Dict{String, IoK8sApimachineryPkgApiResourceQuantity} : Max usage constraints on this kind by resource name.
    - maxLimitRequestRatio::Dict{String, IoK8sApimachineryPkgApiResourceQuantity} : MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value; this represents the max burst for the named resource.
    - min::Dict{String, IoK8sApimachineryPkgApiResourceQuantity} : Min usage constraints on this kind by resource name.
    - type::String : Type of resource that this limit applies to.
"""
mutable struct IoK8sApiCoreV1LimitRangeItem <: SwaggerModel
    default::Any # spec type: Union{ Nothing, Dict{String, IoK8sApimachineryPkgApiResourceQuantity} } # spec name: default
    defaultRequest::Any # spec type: Union{ Nothing, Dict{String, IoK8sApimachineryPkgApiResourceQuantity} } # spec name: defaultRequest
    max::Any # spec type: Union{ Nothing, Dict{String, IoK8sApimachineryPkgApiResourceQuantity} } # spec name: max
    maxLimitRequestRatio::Any # spec type: Union{ Nothing, Dict{String, IoK8sApimachineryPkgApiResourceQuantity} } # spec name: maxLimitRequestRatio
    min::Any # spec type: Union{ Nothing, Dict{String, IoK8sApimachineryPkgApiResourceQuantity} } # spec name: min
    type::Any # spec type: Union{ Nothing, String } # spec name: type

    function IoK8sApiCoreV1LimitRangeItem(;default=nothing, defaultRequest=nothing, max=nothing, maxLimitRequestRatio=nothing, min=nothing, type=nothing)
        o = new()
        validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("default"), default)
        setfield!(o, Symbol("default"), default)
        validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("defaultRequest"), defaultRequest)
        setfield!(o, Symbol("defaultRequest"), defaultRequest)
        validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("max"), max)
        setfield!(o, Symbol("max"), max)
        validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("maxLimitRequestRatio"), maxLimitRequestRatio)
        setfield!(o, Symbol("maxLimitRequestRatio"), maxLimitRequestRatio)
        validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("min"), min)
        setfield!(o, Symbol("min"), min)
        validate_property(IoK8sApiCoreV1LimitRangeItem, Symbol("type"), type)
        setfield!(o, Symbol("type"), type)
        o
    end
end # type IoK8sApiCoreV1LimitRangeItem

const _property_map_IoK8sApiCoreV1LimitRangeItem = Dict{Symbol,Symbol}(Symbol("default")=>Symbol("default"), Symbol("defaultRequest")=>Symbol("defaultRequest"), Symbol("max")=>Symbol("max"), Symbol("maxLimitRequestRatio")=>Symbol("maxLimitRequestRatio"), Symbol("min")=>Symbol("min"), Symbol("type")=>Symbol("type"))
const _property_types_IoK8sApiCoreV1LimitRangeItem = Dict{Symbol,String}(Symbol("default")=>"Dict{String, IoK8sApimachineryPkgApiResourceQuantity}", Symbol("defaultRequest")=>"Dict{String, IoK8sApimachineryPkgApiResourceQuantity}", Symbol("max")=>"Dict{String, IoK8sApimachineryPkgApiResourceQuantity}", Symbol("maxLimitRequestRatio")=>"Dict{String, IoK8sApimachineryPkgApiResourceQuantity}", Symbol("min")=>"Dict{String, IoK8sApimachineryPkgApiResourceQuantity}", Symbol("type")=>"String")
Base.propertynames(::Type{ IoK8sApiCoreV1LimitRangeItem }) = collect(keys(_property_map_IoK8sApiCoreV1LimitRangeItem))
Swagger.property_type(::Type{ IoK8sApiCoreV1LimitRangeItem }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1LimitRangeItem[name]))}
Swagger.field_name(::Type{ IoK8sApiCoreV1LimitRangeItem }, property_name::Symbol) =  _property_map_IoK8sApiCoreV1LimitRangeItem[property_name]

function check_required(o::IoK8sApiCoreV1LimitRangeItem)
    true
end

function validate_property(::Type{ IoK8sApiCoreV1LimitRangeItem }, name::Symbol, val)
end
