# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""PodSpec is a description of a pod.

    IoK8sApiCoreV1PodSpec(;
        activeDeadlineSeconds=nothing,
        affinity=nothing,
        automountServiceAccountToken=nothing,
        containers=nothing,
        dnsConfig=nothing,
        dnsPolicy=nothing,
        enableServiceLinks=nothing,
        ephemeralContainers=nothing,
        hostAliases=nothing,
        hostIPC=nothing,
        hostNetwork=nothing,
        hostPID=nothing,
        hostname=nothing,
        imagePullSecrets=nothing,
        initContainers=nothing,
        nodeName=nothing,
        nodeSelector=nothing,
        overhead=nothing,
        preemptionPolicy=nothing,
        priority=nothing,
        priorityClassName=nothing,
        readinessGates=nothing,
        restartPolicy=nothing,
        runtimeClassName=nothing,
        schedulerName=nothing,
        securityContext=nothing,
        serviceAccount=nothing,
        serviceAccountName=nothing,
        shareProcessNamespace=nothing,
        subdomain=nothing,
        terminationGracePeriodSeconds=nothing,
        tolerations=nothing,
        topologySpreadConstraints=nothing,
        volumes=nothing,
    )

    - activeDeadlineSeconds::Int64 : Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.
    - affinity::IoK8sApiCoreV1Affinity : If specified, the pod&#39;s scheduling constraints
    - automountServiceAccountToken::Bool : AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.
    - containers::Vector{IoK8sApiCoreV1Container} : List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.
    - dnsConfig::IoK8sApiCoreV1PodDNSConfig : Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.
    - dnsPolicy::String : Set DNS policy for the pod. Defaults to \&quot;ClusterFirst\&quot;. Valid values are &#39;ClusterFirstWithHostNet&#39;, &#39;ClusterFirst&#39;, &#39;Default&#39; or &#39;None&#39;. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to &#39;ClusterFirstWithHostNet&#39;.
    - enableServiceLinks::Bool : EnableServiceLinks indicates whether information about services should be injected into pod&#39;s environment variables, matching the syntax of Docker links. Optional: Defaults to true.
    - ephemeralContainers::Vector{IoK8sApiCoreV1EphemeralContainer} : List of ephemeral containers run in this pod. Ephemeral containers may be run in an existing pod to perform user-initiated actions such as debugging. This list cannot be specified when creating a pod, and it cannot be modified by updating the pod spec. In order to add an ephemeral container to an existing pod, use the pod&#39;s ephemeralcontainers subresource. This field is alpha-level and is only honored by servers that enable the EphemeralContainers feature.
    - hostAliases::Vector{IoK8sApiCoreV1HostAlias} : HostAliases is an optional list of hosts and IPs that will be injected into the pod&#39;s hosts file if specified. This is only valid for non-hostNetwork pods.
    - hostIPC::Bool : Use the host&#39;s ipc namespace. Optional: Default to false.
    - hostNetwork::Bool : Host networking requested for this pod. Use the host&#39;s network namespace. If this option is set, the ports that will be used must be specified. Default to false.
    - hostPID::Bool : Use the host&#39;s pid namespace. Optional: Default to false.
    - hostname::String : Specifies the hostname of the Pod If not specified, the pod&#39;s hostname will be set to a system-defined value.
    - imagePullSecrets::Vector{IoK8sApiCoreV1LocalObjectReference} : ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod
    - initContainers::Vector{IoK8sApiCoreV1Container} : List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/
    - nodeName::String : NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.
    - nodeSelector::Dict{String, String} : NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node&#39;s labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/
    - overhead::Dict{String, IoK8sApimachineryPkgApiResourceQuantity} : Overhead represents the resource overhead associated with running a pod for a given RuntimeClass. This field will be autopopulated at admission time by the RuntimeClass admission controller. If the RuntimeClass admission controller is enabled, overhead must not be set in Pod create requests. The RuntimeClass admission controller will reject Pod create requests which have the overhead already set. If RuntimeClass is configured and selected in the PodSpec, Overhead will be set to the value defined in the corresponding RuntimeClass, otherwise it will remain unset and treated as zero. More info: https://git.k8s.io/enhancements/keps/sig-node/20190226-pod-overhead.md This field is alpha-level as of Kubernetes v1.16, and is only honored by servers that enable the PodOverhead feature.
    - preemptionPolicy::String : PreemptionPolicy is the Policy for preempting pods with lower priority. One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset. This field is alpha-level and is only honored by servers that enable the NonPreemptingPriority feature.
    - priority::Int32 : The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.
    - priorityClassName::String : If specified, indicates the pod&#39;s priority. \&quot;system-node-critical\&quot; and \&quot;system-cluster-critical\&quot; are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.
    - readinessGates::Vector{IoK8sApiCoreV1PodReadinessGate} : If specified, all readiness gates will be evaluated for pod readiness. A pod is ready when all its containers are ready AND all conditions specified in the readiness gates have status equal to \&quot;True\&quot; More info: https://git.k8s.io/enhancements/keps/sig-network/0007-pod-ready%2B%2B.md
    - restartPolicy::String : Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy
    - runtimeClassName::String : RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used to run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run. If unset or empty, the \&quot;legacy\&quot; RuntimeClass will be used, which is an implicit class with an empty definition that uses the default runtime handler. More info: https://git.k8s.io/enhancements/keps/sig-node/runtime-class.md This is a beta feature as of Kubernetes v1.14.
    - schedulerName::String : If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.
    - securityContext::IoK8sApiCoreV1PodSecurityContext : SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.
    - serviceAccount::String : DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.
    - serviceAccountName::String : ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/
    - shareProcessNamespace::Bool : Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false.
    - subdomain::String : If specified, the fully qualified Pod hostname will be \&quot;&lt;hostname&gt;.&lt;subdomain&gt;.&lt;pod namespace&gt;.svc.&lt;cluster domain&gt;\&quot;. If not specified, the pod will not have a domainname at all.
    - terminationGracePeriodSeconds::Int64 : Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.
    - tolerations::Vector{IoK8sApiCoreV1Toleration} : If specified, the pod&#39;s tolerations.
    - topologySpreadConstraints::Vector{IoK8sApiCoreV1TopologySpreadConstraint} : TopologySpreadConstraints describes how a group of pods ought to spread across topology domains. Scheduler will schedule pods in a way which abides by the constraints. This field is alpha-level and is only honored by clusters that enables the EvenPodsSpread feature. All topologySpreadConstraints are ANDed.
    - volumes::Vector{IoK8sApiCoreV1Volume} : List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes
"""
mutable struct IoK8sApiCoreV1PodSpec <: SwaggerModel
    activeDeadlineSeconds::Any # spec type: Union{ Nothing, Int64 } # spec name: activeDeadlineSeconds
    affinity::Any # spec type: Union{ Nothing, IoK8sApiCoreV1Affinity } # spec name: affinity
    automountServiceAccountToken::Any # spec type: Union{ Nothing, Bool } # spec name: automountServiceAccountToken
    containers::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1Container} } # spec name: containers
    dnsConfig::Any # spec type: Union{ Nothing, IoK8sApiCoreV1PodDNSConfig } # spec name: dnsConfig
    dnsPolicy::Any # spec type: Union{ Nothing, String } # spec name: dnsPolicy
    enableServiceLinks::Any # spec type: Union{ Nothing, Bool } # spec name: enableServiceLinks
    ephemeralContainers::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1EphemeralContainer} } # spec name: ephemeralContainers
    hostAliases::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1HostAlias} } # spec name: hostAliases
    hostIPC::Any # spec type: Union{ Nothing, Bool } # spec name: hostIPC
    hostNetwork::Any # spec type: Union{ Nothing, Bool } # spec name: hostNetwork
    hostPID::Any # spec type: Union{ Nothing, Bool } # spec name: hostPID
    hostname::Any # spec type: Union{ Nothing, String } # spec name: hostname
    imagePullSecrets::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1LocalObjectReference} } # spec name: imagePullSecrets
    initContainers::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1Container} } # spec name: initContainers
    nodeName::Any # spec type: Union{ Nothing, String } # spec name: nodeName
    nodeSelector::Any # spec type: Union{ Nothing, Dict{String, String} } # spec name: nodeSelector
    overhead::Any # spec type: Union{ Nothing, Dict{String, IoK8sApimachineryPkgApiResourceQuantity} } # spec name: overhead
    preemptionPolicy::Any # spec type: Union{ Nothing, String } # spec name: preemptionPolicy
    priority::Any # spec type: Union{ Nothing, Int32 } # spec name: priority
    priorityClassName::Any # spec type: Union{ Nothing, String } # spec name: priorityClassName
    readinessGates::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1PodReadinessGate} } # spec name: readinessGates
    restartPolicy::Any # spec type: Union{ Nothing, String } # spec name: restartPolicy
    runtimeClassName::Any # spec type: Union{ Nothing, String } # spec name: runtimeClassName
    schedulerName::Any # spec type: Union{ Nothing, String } # spec name: schedulerName
    securityContext::Any # spec type: Union{ Nothing, IoK8sApiCoreV1PodSecurityContext } # spec name: securityContext
    serviceAccount::Any # spec type: Union{ Nothing, String } # spec name: serviceAccount
    serviceAccountName::Any # spec type: Union{ Nothing, String } # spec name: serviceAccountName
    shareProcessNamespace::Any # spec type: Union{ Nothing, Bool } # spec name: shareProcessNamespace
    subdomain::Any # spec type: Union{ Nothing, String } # spec name: subdomain
    terminationGracePeriodSeconds::Any # spec type: Union{ Nothing, Int64 } # spec name: terminationGracePeriodSeconds
    tolerations::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1Toleration} } # spec name: tolerations
    topologySpreadConstraints::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1TopologySpreadConstraint} } # spec name: topologySpreadConstraints
    volumes::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1Volume} } # spec name: volumes

    function IoK8sApiCoreV1PodSpec(;activeDeadlineSeconds=nothing, affinity=nothing, automountServiceAccountToken=nothing, containers=nothing, dnsConfig=nothing, dnsPolicy=nothing, enableServiceLinks=nothing, ephemeralContainers=nothing, hostAliases=nothing, hostIPC=nothing, hostNetwork=nothing, hostPID=nothing, hostname=nothing, imagePullSecrets=nothing, initContainers=nothing, nodeName=nothing, nodeSelector=nothing, overhead=nothing, preemptionPolicy=nothing, priority=nothing, priorityClassName=nothing, readinessGates=nothing, restartPolicy=nothing, runtimeClassName=nothing, schedulerName=nothing, securityContext=nothing, serviceAccount=nothing, serviceAccountName=nothing, shareProcessNamespace=nothing, subdomain=nothing, terminationGracePeriodSeconds=nothing, tolerations=nothing, topologySpreadConstraints=nothing, volumes=nothing)
        o = new()
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("activeDeadlineSeconds"), activeDeadlineSeconds)
        setfield!(o, Symbol("activeDeadlineSeconds"), activeDeadlineSeconds)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("affinity"), affinity)
        setfield!(o, Symbol("affinity"), affinity)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("automountServiceAccountToken"), automountServiceAccountToken)
        setfield!(o, Symbol("automountServiceAccountToken"), automountServiceAccountToken)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("containers"), containers)
        setfield!(o, Symbol("containers"), containers)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("dnsConfig"), dnsConfig)
        setfield!(o, Symbol("dnsConfig"), dnsConfig)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("dnsPolicy"), dnsPolicy)
        setfield!(o, Symbol("dnsPolicy"), dnsPolicy)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("enableServiceLinks"), enableServiceLinks)
        setfield!(o, Symbol("enableServiceLinks"), enableServiceLinks)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("ephemeralContainers"), ephemeralContainers)
        setfield!(o, Symbol("ephemeralContainers"), ephemeralContainers)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("hostAliases"), hostAliases)
        setfield!(o, Symbol("hostAliases"), hostAliases)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("hostIPC"), hostIPC)
        setfield!(o, Symbol("hostIPC"), hostIPC)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("hostNetwork"), hostNetwork)
        setfield!(o, Symbol("hostNetwork"), hostNetwork)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("hostPID"), hostPID)
        setfield!(o, Symbol("hostPID"), hostPID)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("hostname"), hostname)
        setfield!(o, Symbol("hostname"), hostname)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("imagePullSecrets"), imagePullSecrets)
        setfield!(o, Symbol("imagePullSecrets"), imagePullSecrets)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("initContainers"), initContainers)
        setfield!(o, Symbol("initContainers"), initContainers)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("nodeName"), nodeName)
        setfield!(o, Symbol("nodeName"), nodeName)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("nodeSelector"), nodeSelector)
        setfield!(o, Symbol("nodeSelector"), nodeSelector)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("overhead"), overhead)
        setfield!(o, Symbol("overhead"), overhead)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("preemptionPolicy"), preemptionPolicy)
        setfield!(o, Symbol("preemptionPolicy"), preemptionPolicy)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("priority"), priority)
        setfield!(o, Symbol("priority"), priority)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("priorityClassName"), priorityClassName)
        setfield!(o, Symbol("priorityClassName"), priorityClassName)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("readinessGates"), readinessGates)
        setfield!(o, Symbol("readinessGates"), readinessGates)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("restartPolicy"), restartPolicy)
        setfield!(o, Symbol("restartPolicy"), restartPolicy)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("runtimeClassName"), runtimeClassName)
        setfield!(o, Symbol("runtimeClassName"), runtimeClassName)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("schedulerName"), schedulerName)
        setfield!(o, Symbol("schedulerName"), schedulerName)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("securityContext"), securityContext)
        setfield!(o, Symbol("securityContext"), securityContext)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("serviceAccount"), serviceAccount)
        setfield!(o, Symbol("serviceAccount"), serviceAccount)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("serviceAccountName"), serviceAccountName)
        setfield!(o, Symbol("serviceAccountName"), serviceAccountName)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("shareProcessNamespace"), shareProcessNamespace)
        setfield!(o, Symbol("shareProcessNamespace"), shareProcessNamespace)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("subdomain"), subdomain)
        setfield!(o, Symbol("subdomain"), subdomain)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("terminationGracePeriodSeconds"), terminationGracePeriodSeconds)
        setfield!(o, Symbol("terminationGracePeriodSeconds"), terminationGracePeriodSeconds)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("tolerations"), tolerations)
        setfield!(o, Symbol("tolerations"), tolerations)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("topologySpreadConstraints"), topologySpreadConstraints)
        setfield!(o, Symbol("topologySpreadConstraints"), topologySpreadConstraints)
        validate_property(IoK8sApiCoreV1PodSpec, Symbol("volumes"), volumes)
        setfield!(o, Symbol("volumes"), volumes)
        o
    end
end # type IoK8sApiCoreV1PodSpec

const _property_map_IoK8sApiCoreV1PodSpec = Dict{Symbol,Symbol}(Symbol("activeDeadlineSeconds")=>Symbol("activeDeadlineSeconds"), Symbol("affinity")=>Symbol("affinity"), Symbol("automountServiceAccountToken")=>Symbol("automountServiceAccountToken"), Symbol("containers")=>Symbol("containers"), Symbol("dnsConfig")=>Symbol("dnsConfig"), Symbol("dnsPolicy")=>Symbol("dnsPolicy"), Symbol("enableServiceLinks")=>Symbol("enableServiceLinks"), Symbol("ephemeralContainers")=>Symbol("ephemeralContainers"), Symbol("hostAliases")=>Symbol("hostAliases"), Symbol("hostIPC")=>Symbol("hostIPC"), Symbol("hostNetwork")=>Symbol("hostNetwork"), Symbol("hostPID")=>Symbol("hostPID"), Symbol("hostname")=>Symbol("hostname"), Symbol("imagePullSecrets")=>Symbol("imagePullSecrets"), Symbol("initContainers")=>Symbol("initContainers"), Symbol("nodeName")=>Symbol("nodeName"), Symbol("nodeSelector")=>Symbol("nodeSelector"), Symbol("overhead")=>Symbol("overhead"), Symbol("preemptionPolicy")=>Symbol("preemptionPolicy"), Symbol("priority")=>Symbol("priority"), Symbol("priorityClassName")=>Symbol("priorityClassName"), Symbol("readinessGates")=>Symbol("readinessGates"), Symbol("restartPolicy")=>Symbol("restartPolicy"), Symbol("runtimeClassName")=>Symbol("runtimeClassName"), Symbol("schedulerName")=>Symbol("schedulerName"), Symbol("securityContext")=>Symbol("securityContext"), Symbol("serviceAccount")=>Symbol("serviceAccount"), Symbol("serviceAccountName")=>Symbol("serviceAccountName"), Symbol("shareProcessNamespace")=>Symbol("shareProcessNamespace"), Symbol("subdomain")=>Symbol("subdomain"), Symbol("terminationGracePeriodSeconds")=>Symbol("terminationGracePeriodSeconds"), Symbol("tolerations")=>Symbol("tolerations"), Symbol("topologySpreadConstraints")=>Symbol("topologySpreadConstraints"), Symbol("volumes")=>Symbol("volumes"))
const _property_types_IoK8sApiCoreV1PodSpec = Dict{Symbol,String}(Symbol("activeDeadlineSeconds")=>"Int64", Symbol("affinity")=>"IoK8sApiCoreV1Affinity", Symbol("automountServiceAccountToken")=>"Bool", Symbol("containers")=>"Vector{IoK8sApiCoreV1Container}", Symbol("dnsConfig")=>"IoK8sApiCoreV1PodDNSConfig", Symbol("dnsPolicy")=>"String", Symbol("enableServiceLinks")=>"Bool", Symbol("ephemeralContainers")=>"Vector{IoK8sApiCoreV1EphemeralContainer}", Symbol("hostAliases")=>"Vector{IoK8sApiCoreV1HostAlias}", Symbol("hostIPC")=>"Bool", Symbol("hostNetwork")=>"Bool", Symbol("hostPID")=>"Bool", Symbol("hostname")=>"String", Symbol("imagePullSecrets")=>"Vector{IoK8sApiCoreV1LocalObjectReference}", Symbol("initContainers")=>"Vector{IoK8sApiCoreV1Container}", Symbol("nodeName")=>"String", Symbol("nodeSelector")=>"Dict{String, String}", Symbol("overhead")=>"Dict{String, IoK8sApimachineryPkgApiResourceQuantity}", Symbol("preemptionPolicy")=>"String", Symbol("priority")=>"Int32", Symbol("priorityClassName")=>"String", Symbol("readinessGates")=>"Vector{IoK8sApiCoreV1PodReadinessGate}", Symbol("restartPolicy")=>"String", Symbol("runtimeClassName")=>"String", Symbol("schedulerName")=>"String", Symbol("securityContext")=>"IoK8sApiCoreV1PodSecurityContext", Symbol("serviceAccount")=>"String", Symbol("serviceAccountName")=>"String", Symbol("shareProcessNamespace")=>"Bool", Symbol("subdomain")=>"String", Symbol("terminationGracePeriodSeconds")=>"Int64", Symbol("tolerations")=>"Vector{IoK8sApiCoreV1Toleration}", Symbol("topologySpreadConstraints")=>"Vector{IoK8sApiCoreV1TopologySpreadConstraint}", Symbol("volumes")=>"Vector{IoK8sApiCoreV1Volume}")
Base.propertynames(::Type{ IoK8sApiCoreV1PodSpec }) = collect(keys(_property_map_IoK8sApiCoreV1PodSpec))
Swagger.property_type(::Type{ IoK8sApiCoreV1PodSpec }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1PodSpec[name]))}
Swagger.field_name(::Type{ IoK8sApiCoreV1PodSpec }, property_name::Symbol) =  _property_map_IoK8sApiCoreV1PodSpec[property_name]

function check_required(o::IoK8sApiCoreV1PodSpec)
    (getproperty(o, Symbol("containers")) === nothing) && (return false)
    true
end

function validate_property(::Type{ IoK8sApiCoreV1PodSpec }, name::Symbol, val)
end
