# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""PodStatus represents information about the status of a pod. Status may trail the actual state of a system, especially if the node that hosts the pod cannot contact the control plane.

    IoK8sApiCoreV1PodStatus(;
        conditions=nothing,
        containerStatuses=nothing,
        ephemeralContainerStatuses=nothing,
        hostIP=nothing,
        initContainerStatuses=nothing,
        message=nothing,
        nominatedNodeName=nothing,
        phase=nothing,
        podIP=nothing,
        podIPs=nothing,
        qosClass=nothing,
        reason=nothing,
        startTime=nothing,
    )

    - conditions::Vector{IoK8sApiCoreV1PodCondition} : Current service state of pod. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-conditions
    - containerStatuses::Vector{IoK8sApiCoreV1ContainerStatus} : The list has one entry per container in the manifest. Each entry is currently the output of &#x60;docker inspect&#x60;. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status
    - ephemeralContainerStatuses::Vector{IoK8sApiCoreV1ContainerStatus} : Status for any ephemeral containers that have run in this pod. This field is alpha-level and is only populated by servers that enable the EphemeralContainers feature.
    - hostIP::String : IP address of the host to which the pod is assigned. Empty if not yet scheduled.
    - initContainerStatuses::Vector{IoK8sApiCoreV1ContainerStatus} : The list has one entry per init container in the manifest. The most recent successful init container will have ready &#x3D; true, the most recently started container will have startTime set. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-and-container-status
    - message::String : A human readable message indicating details about why the pod is in this condition.
    - nominatedNodeName::String : nominatedNodeName is set only when this pod preempts other pods on the node, but it cannot be scheduled right away as preemption victims receive their graceful termination periods. This field does not guarantee that the pod will be scheduled on this node. Scheduler may decide to place the pod elsewhere if other nodes become available sooner. Scheduler may also decide to give the resources on this node to a higher priority pod that is created after preemption. As a result, this field may be different than PodSpec.nodeName when the pod is scheduled.
    - phase::String : The phase of a Pod is a simple, high-level summary of where the Pod is in its lifecycle. The conditions array, the reason and message fields, and the individual container status arrays contain more detail about the pod&#39;s status. There are five possible phase values:  Pending: The pod has been accepted by the Kubernetes system, but one or more of the container images has not been created. This includes time before being scheduled as well as time spent downloading images over the network, which could take a while. Running: The pod has been bound to a node, and all of the containers have been created. At least one container is still running, or is in the process of starting or restarting. Succeeded: All containers in the pod have terminated in success, and will not be restarted. Failed: All containers in the pod have terminated, and at least one container has terminated in failure. The container either exited with non-zero status or was terminated by the system. Unknown: For some reason the state of the pod could not be obtained, typically due to an error in communicating with the host of the pod.  More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#pod-phase
    - podIP::String : IP address allocated to the pod. Routable at least within the cluster. Empty if not yet allocated.
    - podIPs::Vector{IoK8sApiCoreV1PodIP} : podIPs holds the IP addresses allocated to the pod. If this field is specified, the 0th entry must match the podIP field. Pods may be allocated at most 1 value for each of IPv4 and IPv6. This list is empty if no IPs have been allocated yet.
    - qosClass::String : The Quality of Service (QOS) classification assigned to the pod based on resource requirements See PodQOSClass type for available QOS classes More info: https://git.k8s.io/community/contributors/design-proposals/node/resource-qos.md
    - reason::String : A brief CamelCase message indicating details about why the pod is in this state. e.g. &#39;Evicted&#39;
    - startTime::IoK8sApimachineryPkgApisMetaV1Time : RFC 3339 date and time at which the object was acknowledged by the Kubelet. This is before the Kubelet pulled the container image(s) for the pod.
"""
mutable struct IoK8sApiCoreV1PodStatus <: SwaggerModel
    conditions::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1PodCondition} } # spec name: conditions
    containerStatuses::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1ContainerStatus} } # spec name: containerStatuses
    ephemeralContainerStatuses::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1ContainerStatus} } # spec name: ephemeralContainerStatuses
    hostIP::Any # spec type: Union{ Nothing, String } # spec name: hostIP
    initContainerStatuses::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1ContainerStatus} } # spec name: initContainerStatuses
    message::Any # spec type: Union{ Nothing, String } # spec name: message
    nominatedNodeName::Any # spec type: Union{ Nothing, String } # spec name: nominatedNodeName
    phase::Any # spec type: Union{ Nothing, String } # spec name: phase
    podIP::Any # spec type: Union{ Nothing, String } # spec name: podIP
    podIPs::Any # spec type: Union{ Nothing, Vector{IoK8sApiCoreV1PodIP} } # spec name: podIPs
    qosClass::Any # spec type: Union{ Nothing, String } # spec name: qosClass
    reason::Any # spec type: Union{ Nothing, String } # spec name: reason
    startTime::Any # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1Time } # spec name: startTime

    function IoK8sApiCoreV1PodStatus(;conditions=nothing, containerStatuses=nothing, ephemeralContainerStatuses=nothing, hostIP=nothing, initContainerStatuses=nothing, message=nothing, nominatedNodeName=nothing, phase=nothing, podIP=nothing, podIPs=nothing, qosClass=nothing, reason=nothing, startTime=nothing)
        o = new()
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("conditions"), conditions)
        setfield!(o, Symbol("conditions"), conditions)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("containerStatuses"), containerStatuses)
        setfield!(o, Symbol("containerStatuses"), containerStatuses)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("ephemeralContainerStatuses"), ephemeralContainerStatuses)
        setfield!(o, Symbol("ephemeralContainerStatuses"), ephemeralContainerStatuses)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("hostIP"), hostIP)
        setfield!(o, Symbol("hostIP"), hostIP)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("initContainerStatuses"), initContainerStatuses)
        setfield!(o, Symbol("initContainerStatuses"), initContainerStatuses)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("message"), message)
        setfield!(o, Symbol("message"), message)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("nominatedNodeName"), nominatedNodeName)
        setfield!(o, Symbol("nominatedNodeName"), nominatedNodeName)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("phase"), phase)
        setfield!(o, Symbol("phase"), phase)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("podIP"), podIP)
        setfield!(o, Symbol("podIP"), podIP)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("podIPs"), podIPs)
        setfield!(o, Symbol("podIPs"), podIPs)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("qosClass"), qosClass)
        setfield!(o, Symbol("qosClass"), qosClass)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("reason"), reason)
        setfield!(o, Symbol("reason"), reason)
        validate_property(IoK8sApiCoreV1PodStatus, Symbol("startTime"), startTime)
        setfield!(o, Symbol("startTime"), startTime)
        o
    end
end # type IoK8sApiCoreV1PodStatus

const _property_map_IoK8sApiCoreV1PodStatus = Dict{Symbol,Symbol}(Symbol("conditions")=>Symbol("conditions"), Symbol("containerStatuses")=>Symbol("containerStatuses"), Symbol("ephemeralContainerStatuses")=>Symbol("ephemeralContainerStatuses"), Symbol("hostIP")=>Symbol("hostIP"), Symbol("initContainerStatuses")=>Symbol("initContainerStatuses"), Symbol("message")=>Symbol("message"), Symbol("nominatedNodeName")=>Symbol("nominatedNodeName"), Symbol("phase")=>Symbol("phase"), Symbol("podIP")=>Symbol("podIP"), Symbol("podIPs")=>Symbol("podIPs"), Symbol("qosClass")=>Symbol("qosClass"), Symbol("reason")=>Symbol("reason"), Symbol("startTime")=>Symbol("startTime"))
const _property_types_IoK8sApiCoreV1PodStatus = Dict{Symbol,String}(Symbol("conditions")=>"Vector{IoK8sApiCoreV1PodCondition}", Symbol("containerStatuses")=>"Vector{IoK8sApiCoreV1ContainerStatus}", Symbol("ephemeralContainerStatuses")=>"Vector{IoK8sApiCoreV1ContainerStatus}", Symbol("hostIP")=>"String", Symbol("initContainerStatuses")=>"Vector{IoK8sApiCoreV1ContainerStatus}", Symbol("message")=>"String", Symbol("nominatedNodeName")=>"String", Symbol("phase")=>"String", Symbol("podIP")=>"String", Symbol("podIPs")=>"Vector{IoK8sApiCoreV1PodIP}", Symbol("qosClass")=>"String", Symbol("reason")=>"String", Symbol("startTime")=>"IoK8sApimachineryPkgApisMetaV1Time")
Base.propertynames(::Type{ IoK8sApiCoreV1PodStatus }) = collect(keys(_property_map_IoK8sApiCoreV1PodStatus))
Swagger.property_type(::Type{ IoK8sApiCoreV1PodStatus }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1PodStatus[name]))}
Swagger.field_name(::Type{ IoK8sApiCoreV1PodStatus }, property_name::Symbol) =  _property_map_IoK8sApiCoreV1PodStatus[property_name]

function check_required(o::IoK8sApiCoreV1PodStatus)
    true
end

function validate_property(::Type{ IoK8sApiCoreV1PodStatus }, name::Symbol, val)
end
