# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""WindowsSecurityContextOptions contain Windows-specific options and credentials.

    IoK8sApiCoreV1WindowsSecurityContextOptions(;
        gmsaCredentialSpec=nothing,
        gmsaCredentialSpecName=nothing,
        runAsUserName=nothing,
    )

    - gmsaCredentialSpec::String : GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag.
    - gmsaCredentialSpecName::String : GMSACredentialSpecName is the name of the GMSA credential spec to use. This field is alpha-level and is only honored by servers that enable the WindowsGMSA feature flag.
    - runAsUserName::String : The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. This field is beta-level and may be disabled with the WindowsRunAsUserName feature flag.
"""
mutable struct IoK8sApiCoreV1WindowsSecurityContextOptions <: SwaggerModel
    gmsaCredentialSpec::Any # spec type: Union{ Nothing, String } # spec name: gmsaCredentialSpec
    gmsaCredentialSpecName::Any # spec type: Union{ Nothing, String } # spec name: gmsaCredentialSpecName
    runAsUserName::Any # spec type: Union{ Nothing, String } # spec name: runAsUserName

    function IoK8sApiCoreV1WindowsSecurityContextOptions(;gmsaCredentialSpec=nothing, gmsaCredentialSpecName=nothing, runAsUserName=nothing)
        o = new()
        validate_property(IoK8sApiCoreV1WindowsSecurityContextOptions, Symbol("gmsaCredentialSpec"), gmsaCredentialSpec)
        setfield!(o, Symbol("gmsaCredentialSpec"), gmsaCredentialSpec)
        validate_property(IoK8sApiCoreV1WindowsSecurityContextOptions, Symbol("gmsaCredentialSpecName"), gmsaCredentialSpecName)
        setfield!(o, Symbol("gmsaCredentialSpecName"), gmsaCredentialSpecName)
        validate_property(IoK8sApiCoreV1WindowsSecurityContextOptions, Symbol("runAsUserName"), runAsUserName)
        setfield!(o, Symbol("runAsUserName"), runAsUserName)
        o
    end
end # type IoK8sApiCoreV1WindowsSecurityContextOptions

const _property_map_IoK8sApiCoreV1WindowsSecurityContextOptions = Dict{Symbol,Symbol}(Symbol("gmsaCredentialSpec")=>Symbol("gmsaCredentialSpec"), Symbol("gmsaCredentialSpecName")=>Symbol("gmsaCredentialSpecName"), Symbol("runAsUserName")=>Symbol("runAsUserName"))
const _property_types_IoK8sApiCoreV1WindowsSecurityContextOptions = Dict{Symbol,String}(Symbol("gmsaCredentialSpec")=>"String", Symbol("gmsaCredentialSpecName")=>"String", Symbol("runAsUserName")=>"String")
Base.propertynames(::Type{ IoK8sApiCoreV1WindowsSecurityContextOptions }) = collect(keys(_property_map_IoK8sApiCoreV1WindowsSecurityContextOptions))
Swagger.property_type(::Type{ IoK8sApiCoreV1WindowsSecurityContextOptions }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiCoreV1WindowsSecurityContextOptions[name]))}
Swagger.field_name(::Type{ IoK8sApiCoreV1WindowsSecurityContextOptions }, property_name::Symbol) =  _property_map_IoK8sApiCoreV1WindowsSecurityContextOptions[property_name]

function check_required(o::IoK8sApiCoreV1WindowsSecurityContextOptions)
    true
end

function validate_property(::Type{ IoK8sApiCoreV1WindowsSecurityContextOptions }, name::Symbol, val)
end
