# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""Event is a report of an event somewhere in the cluster. It generally denotes some state change in the system.

    IoK8sApiEventsV1beta1Event(;
        action=nothing,
        apiVersion=nothing,
        deprecatedCount=nothing,
        deprecatedFirstTimestamp=nothing,
        deprecatedLastTimestamp=nothing,
        deprecatedSource=nothing,
        eventTime=nothing,
        kind=nothing,
        metadata=nothing,
        note=nothing,
        reason=nothing,
        regarding=nothing,
        related=nothing,
        reportingController=nothing,
        reportingInstance=nothing,
        series=nothing,
        type=nothing,
    )

    - action::String : What action was taken/failed regarding to the regarding object.
    - apiVersion::String : APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
    - deprecatedCount::Int32 : Deprecated field assuring backward compatibility with core.v1 Event type
    - deprecatedFirstTimestamp::IoK8sApimachineryPkgApisMetaV1Time : Deprecated field assuring backward compatibility with core.v1 Event type
    - deprecatedLastTimestamp::IoK8sApimachineryPkgApisMetaV1Time : Deprecated field assuring backward compatibility with core.v1 Event type
    - deprecatedSource::IoK8sApiCoreV1EventSource : Deprecated field assuring backward compatibility with core.v1 Event type
    - eventTime::IoK8sApimachineryPkgApisMetaV1MicroTime : Required. Time when this Event was first observed.
    - kind::String : Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
    - metadata::IoK8sApimachineryPkgApisMetaV1ObjectMeta
    - note::String : Optional. A human-readable description of the status of this operation. Maximal length of the note is 1kB, but libraries should be prepared to handle values up to 64kB.
    - reason::String : Why the action was taken.
    - regarding::IoK8sApiCoreV1ObjectReference : The object this Event is about. In most cases it&#39;s an Object reporting controller implements. E.g. ReplicaSetController implements ReplicaSets and this event is emitted because it acts on some changes in a ReplicaSet object.
    - related::IoK8sApiCoreV1ObjectReference : Optional secondary object for more complex actions. E.g. when regarding object triggers a creation or deletion of related object.
    - reportingController::String : Name of the controller that emitted this Event, e.g. &#x60;kubernetes.io/kubelet&#x60;.
    - reportingInstance::String : ID of the controller instance, e.g. &#x60;kubelet-xyzf&#x60;.
    - series::IoK8sApiEventsV1beta1EventSeries : Data about the Event series this event represents or nil if it&#39;s a singleton Event.
    - type::String : Type of this event (Normal, Warning), new types could be added in the future.
"""
mutable struct IoK8sApiEventsV1beta1Event <: SwaggerModel
    action::Any # spec type: Union{ Nothing, String } # spec name: action
    apiVersion::Any # spec type: Union{ Nothing, String } # spec name: apiVersion
    deprecatedCount::Any # spec type: Union{ Nothing, Int32 } # spec name: deprecatedCount
    deprecatedFirstTimestamp::Any # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1Time } # spec name: deprecatedFirstTimestamp
    deprecatedLastTimestamp::Any # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1Time } # spec name: deprecatedLastTimestamp
    deprecatedSource::Any # spec type: Union{ Nothing, IoK8sApiCoreV1EventSource } # spec name: deprecatedSource
    eventTime::Any # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1MicroTime } # spec name: eventTime
    kind::Any # spec type: Union{ Nothing, String } # spec name: kind
    metadata::Any # spec type: Union{ Nothing, IoK8sApimachineryPkgApisMetaV1ObjectMeta } # spec name: metadata
    note::Any # spec type: Union{ Nothing, String } # spec name: note
    reason::Any # spec type: Union{ Nothing, String } # spec name: reason
    regarding::Any # spec type: Union{ Nothing, IoK8sApiCoreV1ObjectReference } # spec name: regarding
    related::Any # spec type: Union{ Nothing, IoK8sApiCoreV1ObjectReference } # spec name: related
    reportingController::Any # spec type: Union{ Nothing, String } # spec name: reportingController
    reportingInstance::Any # spec type: Union{ Nothing, String } # spec name: reportingInstance
    series::Any # spec type: Union{ Nothing, IoK8sApiEventsV1beta1EventSeries } # spec name: series
    type::Any # spec type: Union{ Nothing, String } # spec name: type

    function IoK8sApiEventsV1beta1Event(;action=nothing, apiVersion=nothing, deprecatedCount=nothing, deprecatedFirstTimestamp=nothing, deprecatedLastTimestamp=nothing, deprecatedSource=nothing, eventTime=nothing, kind=nothing, metadata=nothing, note=nothing, reason=nothing, regarding=nothing, related=nothing, reportingController=nothing, reportingInstance=nothing, series=nothing, type=nothing)
        o = new()
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("action"), action)
        setfield!(o, Symbol("action"), action)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("apiVersion"), apiVersion)
        setfield!(o, Symbol("apiVersion"), apiVersion)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("deprecatedCount"), deprecatedCount)
        setfield!(o, Symbol("deprecatedCount"), deprecatedCount)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("deprecatedFirstTimestamp"), deprecatedFirstTimestamp)
        setfield!(o, Symbol("deprecatedFirstTimestamp"), deprecatedFirstTimestamp)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("deprecatedLastTimestamp"), deprecatedLastTimestamp)
        setfield!(o, Symbol("deprecatedLastTimestamp"), deprecatedLastTimestamp)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("deprecatedSource"), deprecatedSource)
        setfield!(o, Symbol("deprecatedSource"), deprecatedSource)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("eventTime"), eventTime)
        setfield!(o, Symbol("eventTime"), eventTime)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("kind"), kind)
        setfield!(o, Symbol("kind"), kind)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("metadata"), metadata)
        setfield!(o, Symbol("metadata"), metadata)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("note"), note)
        setfield!(o, Symbol("note"), note)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("reason"), reason)
        setfield!(o, Symbol("reason"), reason)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("regarding"), regarding)
        setfield!(o, Symbol("regarding"), regarding)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("related"), related)
        setfield!(o, Symbol("related"), related)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("reportingController"), reportingController)
        setfield!(o, Symbol("reportingController"), reportingController)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("reportingInstance"), reportingInstance)
        setfield!(o, Symbol("reportingInstance"), reportingInstance)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("series"), series)
        setfield!(o, Symbol("series"), series)
        validate_property(IoK8sApiEventsV1beta1Event, Symbol("type"), type)
        setfield!(o, Symbol("type"), type)
        o
    end
end # type IoK8sApiEventsV1beta1Event

const _property_map_IoK8sApiEventsV1beta1Event = Dict{Symbol,Symbol}(Symbol("action")=>Symbol("action"), Symbol("apiVersion")=>Symbol("apiVersion"), Symbol("deprecatedCount")=>Symbol("deprecatedCount"), Symbol("deprecatedFirstTimestamp")=>Symbol("deprecatedFirstTimestamp"), Symbol("deprecatedLastTimestamp")=>Symbol("deprecatedLastTimestamp"), Symbol("deprecatedSource")=>Symbol("deprecatedSource"), Symbol("eventTime")=>Symbol("eventTime"), Symbol("kind")=>Symbol("kind"), Symbol("metadata")=>Symbol("metadata"), Symbol("note")=>Symbol("note"), Symbol("reason")=>Symbol("reason"), Symbol("regarding")=>Symbol("regarding"), Symbol("related")=>Symbol("related"), Symbol("reportingController")=>Symbol("reportingController"), Symbol("reportingInstance")=>Symbol("reportingInstance"), Symbol("series")=>Symbol("series"), Symbol("type")=>Symbol("type"))
const _property_types_IoK8sApiEventsV1beta1Event = Dict{Symbol,String}(Symbol("action")=>"String", Symbol("apiVersion")=>"String", Symbol("deprecatedCount")=>"Int32", Symbol("deprecatedFirstTimestamp")=>"IoK8sApimachineryPkgApisMetaV1Time", Symbol("deprecatedLastTimestamp")=>"IoK8sApimachineryPkgApisMetaV1Time", Symbol("deprecatedSource")=>"IoK8sApiCoreV1EventSource", Symbol("eventTime")=>"IoK8sApimachineryPkgApisMetaV1MicroTime", Symbol("kind")=>"String", Symbol("metadata")=>"IoK8sApimachineryPkgApisMetaV1ObjectMeta", Symbol("note")=>"String", Symbol("reason")=>"String", Symbol("regarding")=>"IoK8sApiCoreV1ObjectReference", Symbol("related")=>"IoK8sApiCoreV1ObjectReference", Symbol("reportingController")=>"String", Symbol("reportingInstance")=>"String", Symbol("series")=>"IoK8sApiEventsV1beta1EventSeries", Symbol("type")=>"String")
Base.propertynames(::Type{ IoK8sApiEventsV1beta1Event }) = collect(keys(_property_map_IoK8sApiEventsV1beta1Event))
Swagger.property_type(::Type{ IoK8sApiEventsV1beta1Event }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiEventsV1beta1Event[name]))}
Swagger.field_name(::Type{ IoK8sApiEventsV1beta1Event }, property_name::Symbol) =  _property_map_IoK8sApiEventsV1beta1Event[property_name]

function check_required(o::IoK8sApiEventsV1beta1Event)
    (getproperty(o, Symbol("eventTime")) === nothing) && (return false)
    true
end

function validate_property(::Type{ IoK8sApiEventsV1beta1Event }, name::Symbol, val)
end
