# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""CSINodeDriver holds information about the specification of one CSI driver installed on a node

    IoK8sApiStorageV1beta1CSINodeDriver(;
        allocatable=nothing,
        name=nothing,
        nodeID=nothing,
        topologyKeys=nothing,
    )

    - allocatable::IoK8sApiStorageV1beta1VolumeNodeResources : allocatable represents the volume resources of a node that are available for scheduling.
    - name::String : This is the name of the CSI driver that this object refers to. This MUST be the same name returned by the CSI GetPluginName() call for that driver.
    - nodeID::String : nodeID of the node from the driver point of view. This field enables Kubernetes to communicate with storage systems that do not share the same nomenclature for nodes. For example, Kubernetes may refer to a given node as \&quot;node1\&quot;, but the storage system may refer to the same node as \&quot;nodeA\&quot;. When Kubernetes issues a command to the storage system to attach a volume to a specific node, it can use this field to refer to the node name using the ID that the storage system will understand, e.g. \&quot;nodeA\&quot; instead of \&quot;node1\&quot;. This field is required.
    - topologyKeys::Vector{String} : topologyKeys is the list of keys supported by the driver. When a driver is initialized on a cluster, it provides a set of topology keys that it understands (e.g. \&quot;company.com/zone\&quot;, \&quot;company.com/region\&quot;). When a driver is initialized on a node, it provides the same topology keys along with values. Kubelet will expose these topology keys as labels on its own node object. When Kubernetes does topology aware provisioning, it can use this list to determine which labels it should retrieve from the node object and pass back to the driver. It is possible for different nodes to use different topology keys. This can be empty if driver does not support topology.
"""
mutable struct IoK8sApiStorageV1beta1CSINodeDriver <: SwaggerModel
    allocatable::Any # spec type: Union{ Nothing, IoK8sApiStorageV1beta1VolumeNodeResources } # spec name: allocatable
    name::Any # spec type: Union{ Nothing, String } # spec name: name
    nodeID::Any # spec type: Union{ Nothing, String } # spec name: nodeID
    topologyKeys::Any # spec type: Union{ Nothing, Vector{String} } # spec name: topologyKeys

    function IoK8sApiStorageV1beta1CSINodeDriver(;allocatable=nothing, name=nothing, nodeID=nothing, topologyKeys=nothing)
        o = new()
        validate_property(IoK8sApiStorageV1beta1CSINodeDriver, Symbol("allocatable"), allocatable)
        setfield!(o, Symbol("allocatable"), allocatable)
        validate_property(IoK8sApiStorageV1beta1CSINodeDriver, Symbol("name"), name)
        setfield!(o, Symbol("name"), name)
        validate_property(IoK8sApiStorageV1beta1CSINodeDriver, Symbol("nodeID"), nodeID)
        setfield!(o, Symbol("nodeID"), nodeID)
        validate_property(IoK8sApiStorageV1beta1CSINodeDriver, Symbol("topologyKeys"), topologyKeys)
        setfield!(o, Symbol("topologyKeys"), topologyKeys)
        o
    end
end # type IoK8sApiStorageV1beta1CSINodeDriver

const _property_map_IoK8sApiStorageV1beta1CSINodeDriver = Dict{Symbol,Symbol}(Symbol("allocatable")=>Symbol("allocatable"), Symbol("name")=>Symbol("name"), Symbol("nodeID")=>Symbol("nodeID"), Symbol("topologyKeys")=>Symbol("topologyKeys"))
const _property_types_IoK8sApiStorageV1beta1CSINodeDriver = Dict{Symbol,String}(Symbol("allocatable")=>"IoK8sApiStorageV1beta1VolumeNodeResources", Symbol("name")=>"String", Symbol("nodeID")=>"String", Symbol("topologyKeys")=>"Vector{String}")
Base.propertynames(::Type{ IoK8sApiStorageV1beta1CSINodeDriver }) = collect(keys(_property_map_IoK8sApiStorageV1beta1CSINodeDriver))
Swagger.property_type(::Type{ IoK8sApiStorageV1beta1CSINodeDriver }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApiStorageV1beta1CSINodeDriver[name]))}
Swagger.field_name(::Type{ IoK8sApiStorageV1beta1CSINodeDriver }, property_name::Symbol) =  _property_map_IoK8sApiStorageV1beta1CSINodeDriver[property_name]

function check_required(o::IoK8sApiStorageV1beta1CSINodeDriver)
    (getproperty(o, Symbol("name")) === nothing) && (return false)
    (getproperty(o, Symbol("nodeID")) === nothing) && (return false)
    true
end

function validate_property(::Type{ IoK8sApiStorageV1beta1CSINodeDriver }, name::Symbol, val)
end
