# This file was generated by the Julia Swagger Code Generator
# Do not modify this file directly. Modify the swagger specification instead.


@doc raw"""APIResource specifies the name of a resource and whether it is namespaced.

    IoK8sApimachineryPkgApisMetaV1APIResource(;
        categories=nothing,
        group=nothing,
        kind=nothing,
        name=nothing,
        namespaced=nothing,
        shortNames=nothing,
        singularName=nothing,
        storageVersionHash=nothing,
        verbs=nothing,
        version=nothing,
    )

    - categories::Vector{String} : categories is a list of the grouped resources this resource belongs to (e.g. &#39;all&#39;)
    - group::String : group is the preferred group of the resource.  Empty implies the group of the containing resource list. For subresources, this may have a different value, for example: Scale\&quot;.
    - kind::String : kind is the kind for the resource (e.g. &#39;Foo&#39; is the kind for a resource &#39;foo&#39;)
    - name::String : name is the plural name of the resource.
    - namespaced::Bool : namespaced indicates if a resource is namespaced or not.
    - shortNames::Vector{String} : shortNames is a list of suggested short names of the resource.
    - singularName::String : singularName is the singular name of the resource.  This allows clients to handle plural and singular opaquely. The singularName is more correct for reporting status on a single item and both singular and plural are allowed from the kubectl CLI interface.
    - storageVersionHash::String : The hash value of the storage version, the version this resource is converted to when written to the data store. Value must be treated as opaque by clients. Only equality comparison on the value is valid. This is an alpha feature and may change or be removed in the future. The field is populated by the apiserver only if the StorageVersionHash feature gate is enabled. This field will remain optional even if it graduates.
    - verbs::Vector{String} : verbs is a list of supported kube verbs (this includes get, list, watch, create, update, patch, delete, deletecollection, and proxy)
    - version::String : version is the preferred version of the resource.  Empty implies the version of the containing resource list For subresources, this may have a different value, for example: v1 (while inside a v1beta1 version of the core resource&#39;s group)\&quot;.
"""
mutable struct IoK8sApimachineryPkgApisMetaV1APIResource <: SwaggerModel
    categories::Any # spec type: Union{ Nothing, Vector{String} } # spec name: categories
    group::Any # spec type: Union{ Nothing, String } # spec name: group
    kind::Any # spec type: Union{ Nothing, String } # spec name: kind
    name::Any # spec type: Union{ Nothing, String } # spec name: name
    namespaced::Any # spec type: Union{ Nothing, Bool } # spec name: namespaced
    shortNames::Any # spec type: Union{ Nothing, Vector{String} } # spec name: shortNames
    singularName::Any # spec type: Union{ Nothing, String } # spec name: singularName
    storageVersionHash::Any # spec type: Union{ Nothing, String } # spec name: storageVersionHash
    verbs::Any # spec type: Union{ Nothing, Vector{String} } # spec name: verbs
    version::Any # spec type: Union{ Nothing, String } # spec name: version

    function IoK8sApimachineryPkgApisMetaV1APIResource(;categories=nothing, group=nothing, kind=nothing, name=nothing, namespaced=nothing, shortNames=nothing, singularName=nothing, storageVersionHash=nothing, verbs=nothing, version=nothing)
        o = new()
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("categories"), categories)
        setfield!(o, Symbol("categories"), categories)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("group"), group)
        setfield!(o, Symbol("group"), group)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("kind"), kind)
        setfield!(o, Symbol("kind"), kind)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("name"), name)
        setfield!(o, Symbol("name"), name)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("namespaced"), namespaced)
        setfield!(o, Symbol("namespaced"), namespaced)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("shortNames"), shortNames)
        setfield!(o, Symbol("shortNames"), shortNames)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("singularName"), singularName)
        setfield!(o, Symbol("singularName"), singularName)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("storageVersionHash"), storageVersionHash)
        setfield!(o, Symbol("storageVersionHash"), storageVersionHash)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("verbs"), verbs)
        setfield!(o, Symbol("verbs"), verbs)
        validate_property(IoK8sApimachineryPkgApisMetaV1APIResource, Symbol("version"), version)
        setfield!(o, Symbol("version"), version)
        o
    end
end # type IoK8sApimachineryPkgApisMetaV1APIResource

const _property_map_IoK8sApimachineryPkgApisMetaV1APIResource = Dict{Symbol,Symbol}(Symbol("categories")=>Symbol("categories"), Symbol("group")=>Symbol("group"), Symbol("kind")=>Symbol("kind"), Symbol("name")=>Symbol("name"), Symbol("namespaced")=>Symbol("namespaced"), Symbol("shortNames")=>Symbol("shortNames"), Symbol("singularName")=>Symbol("singularName"), Symbol("storageVersionHash")=>Symbol("storageVersionHash"), Symbol("verbs")=>Symbol("verbs"), Symbol("version")=>Symbol("version"))
const _property_types_IoK8sApimachineryPkgApisMetaV1APIResource = Dict{Symbol,String}(Symbol("categories")=>"Vector{String}", Symbol("group")=>"String", Symbol("kind")=>"String", Symbol("name")=>"String", Symbol("namespaced")=>"Bool", Symbol("shortNames")=>"Vector{String}", Symbol("singularName")=>"String", Symbol("storageVersionHash")=>"String", Symbol("verbs")=>"Vector{String}", Symbol("version")=>"String")
Base.propertynames(::Type{ IoK8sApimachineryPkgApisMetaV1APIResource }) = collect(keys(_property_map_IoK8sApimachineryPkgApisMetaV1APIResource))
Swagger.property_type(::Type{ IoK8sApimachineryPkgApisMetaV1APIResource }, name::Symbol) = Union{Nothing,eval(Base.Meta.parse(_property_types_IoK8sApimachineryPkgApisMetaV1APIResource[name]))}
Swagger.field_name(::Type{ IoK8sApimachineryPkgApisMetaV1APIResource }, property_name::Symbol) =  _property_map_IoK8sApimachineryPkgApisMetaV1APIResource[property_name]

function check_required(o::IoK8sApimachineryPkgApisMetaV1APIResource)
    (getproperty(o, Symbol("kind")) === nothing) && (return false)
    (getproperty(o, Symbol("name")) === nothing) && (return false)
    (getproperty(o, Symbol("namespaced")) === nothing) && (return false)
    (getproperty(o, Symbol("singularName")) === nothing) && (return false)
    (getproperty(o, Symbol("verbs")) === nothing) && (return false)
    true
end

function validate_property(::Type{ IoK8sApimachineryPkgApisMetaV1APIResource }, name::Symbol, val)
end
